commit 66ead3e6507073db227c6dbc4bc1409498d2fa14
Author: Marek Polacek <polacek@redhat.com>
Date:   Tue Nov 18 21:23:20 2025

    c++: fix ICE when comparing targs [PR119580]
    
    In r10-7816, cp_tree_equal/TEMPLATE_ID_EXPR was changed to use
    comp_template_args to compare the targs.  This makes sense, but
    comp_template_args won't deal with an error_mark_node.  We created
    a BASELINK for S::foo<T::value_type>, but since value_type couldn't
    be looked up, we ended up with an error_mark_node instead of a TREE_VEC
    of arguments for the TEMPLATE_ID_EXPR in the BASELINK.
    
    It seems reasonable not to create such a TEMPLATE_ID_EXPR by checking
    the result of tsubst_template_args like we do in so many other places.
    This changes the diagnostic in three tests, but it's only the followup
    error message after complaining about the type/value mismatch.
    
            PR c++/119580
    
    gcc/cp/ChangeLog:
    
            * pt.cc (tsubst_baselink): Return error_mark_node if
            tsubst_template_args returned error_mark_node.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/template/crash106.C: Adjust expected diagnostics.
            * g++.dg/template/crash112.C: Likewise.
            * g++.dg/template/dependent-args1.C: Likewise.
            * g++.dg/cpp0x/pr119580.C: New test.
    
    Reviewed-by: Jason Merrill <jason@redhat.com>
    (cherry picked from commit e2faea35a1edf6fca4d98800a1d9566db04a133b)

diff --git a/gcc/cp/pt.cc b/gcc/cp/pt.cc
index 1b51d32228d..04f1d02e030 100644
--- a/gcc/cp/pt.cc
+++ b/gcc/cp/pt.cc
@@ -17449,6 +17449,8 @@ tsubst_baselink (tree baselink, tree object_type,
       if (template_args)
 	template_args = tsubst_template_args (template_args, args,
 					      complain, in_decl);
+      if (template_args == error_mark_node)
+	return error_mark_node;
     }
 
   tree binfo_type = BINFO_TYPE (BASELINK_BINFO (baselink));
diff --git a/gcc/testsuite/g++.dg/cpp0x/pr119580.C b/gcc/testsuite/g++.dg/cpp0x/pr119580.C
new file mode 100644
index 00000000000..598ddbb0e61
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/pr119580.C
@@ -0,0 +1,16 @@
+// PR c++/119580
+// { dg-do compile { target c++11 } }
+
+template<typename> struct V;
+template<typename> class C;
+class F;
+
+struct S {
+  template<typename>
+  static void foo ();
+  template<typename T, typename>
+  C<decltype(S::foo<T::value_type>)> foo ();
+  decltype(foo<V<F>>()) *a;
+};
+
+S s;
